#include	<iostream>
#include	<string>
#include	<type_traits>
#include	<typeinfo>

#include	<boost/fusion/include/map.hpp>
#include	<boost/fusion/include/filter_if.hpp>
#include	<boost/fusion/include/for_each.hpp>

namespace fusion = boost::fusion;

template<typename Key_Base_T, typename Pair_T>
struct is_same_key: public std::is_same<Key_Base_T, typename Pair_T::first_type> {};

struct print_ftor {
	template<typename Key_T, typename Value_T>
	inline void
	operator()(const boost::fusion::pair<Key_T, Value_T>& pair) const {
		std::cout << "type: " << typeid(Key_T).name() << ", value: " << pair.second << std::endl;
	}
};

int main () {

	typedef fusion::map<	fusion::pair<int, char>,
							fusion::pair<double, std::string>	>
			map_type;

	map_type map_sequence(	fusion::make_pair<int>('X'),
							fusion::make_pair<double>("Men")	);

	fusion::for_each(	fusion::filter_if< is_same_key< double, boost::mpl::_1> >(map_sequence),
						print_ftor());

	return 0;
}
